%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data Analysis Code
% Manuscript titled: "Collective turns in jackdaw flocks: kinematics and information transfer"
% Authors: Hangjian Ling, Guillam E. Mclvor, Joseph Westley, Kasper van der Vaart, Jennify Yin
%          Richard T. Vaughan, Alex Thornton, Nicholas T. Ouellette
% Manuscript submited to "Journal of The Royal Society Interface"
% Date 2019/06
% writen by: Hangjian Ling 
%            Stanford University
% email:     linghj@stanford.edu
%% Figure S13: pairwise subgroups in transit and mobbing flock
clear all;clc
%%%% For winter flock, group #03
% load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/059b.mat'); Frames=590:590+300;Rangex=5;Rangey=4;
%%%% For winter flock, group #04
% load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/063.mat'); Frames=650:650+300;Rangex=5;Rangey=4;
% %%%% For winter flock, group #05
% load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/063.mat'); Frames=1010:1010+300;Rangex=5;Rangey=4;
% %%%% For winter flock, group #07
% load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/100.mat'); Frames=260:260+300;Rangex=5;Rangey=4;

% %%%% For summer flock, group #03
% load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/112.mat'); Frames=2720:2720+300;Rangex=5;Rangey=4;
% %%%% For summer flock, group #04
% load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/112.mat'); Frames=3900:3900+300;Rangex=5;Rangey=4;
%%%% For summer flock, group #05
% load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/112.mat'); Frames=4600:4600+300;Rangex=5;Rangey=4;
%%%% For summer flock, group #07
load('/Users/ling/Downloads/Data_bird/Track_results/tracks_mat/113.mat'); Frames=3200:3200+300;Rangex=5;Rangey=4;

%% start
T=unique(tracks_filt(:,5));
D_rank=[];
for i=Frames
    curFrame=T(i);
    id=find(tracks_filt(:,5)==curFrame);
    XYZ=tracks_filt(id,2:4);
    NumT=unique(tracks_filt(id,1));
    if length(NumT)<5
        continue;
    end
    for j=1:length(NumT)
        xyz1=XYZ(j,:);
        Dist_rank=sum((xyz1-XYZ).^2,2).^0.5;
        [Dist_rank,I]=sort(Dist_rank);
        D_rank=[D_rank;Dist_rank(2:5)'];
    end
end
D_rank_ave=mean(D_rank,1);

figure('units','inches','position',[2 2 3 2.5]);
gridN=20;
xi = linspace(0,Rangex,gridN); 
yi = linspace(0,Rangey,gridN);
histmat=hist2(D_rank(:,2), D_rank(:,1), xi, yi);
histmat2=imgaussfilt(histmat,1,'FilterSize',5);
histmat2=histmat2/max(histmat2(:));
imagesc(xi,yi,histmat2');hold on;
colormap(flipud(hot));
colorbar('Ticks',0:0.5:1,'FontSize',10,'Position',[0.85 0.22 0.04 0.6]); %
[C,h]=contour(xi,yi,histmat2',[0.1 0.3],'linecolor','k','lineWidth',1);
clabel(C,h,[0.1 0.3],'FontSize',12,'Color','k','LabelSpacing',100,'FontName','Times');
axis([0.3 Rangex 0.3 Rangey]);box off
set(gca,'Position',[0.1 0.15 0.70 0.78])
set(gca,'FontSize',12,'FontName','Times','TickLength',[0.03, 0.01]); 
set(gca,'YDir','normal')