%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data Analysis Code
% Manuscript titled: "Collective turns in jackdaw flocks: kinematics and information transfer"
% Authors: Hangjian Ling, Guillam E. Mclvor, Joseph Westley, Kasper van der Vaart, Jennify Yin
%          Richard T. Vaughan, Alex Thornton, Nicholas T. Ouellette
% Manuscript submited to "Journal of The Royal Society Interface"
% Date 2019/06
% writen by: Hangjian Ling 
%            Stanford University
% email:     linghj@stanford.edu
%% Figure S8: effect of group size and polarization on turn start locations
clear all;clc
%%%% 8(a) effect of polarization on Information transfer direction 
figure('units','inches','position',[2 2 3 2.5]);
load('Info_turnStart_T.mat')
plot(p_all,Ang*180/pi,'ko','MarkerSize',10,'MarkerFaceColor',[0.3 1 0.3]);hold on
load('Info_turnStart_M.mat')
plot(p_all,Ang*180/pi,'k^','MarkerSize',10,'MarkerFaceColor',[1 0.3 0.3]);hold on
axis([0.7 1 0 180]);
set(gca,'Position',[0.15 0.15 0.75 0.75])
set(gca,'FontSize',12,'FontName','times','TickLength',[0.03, 0.01],...
    'XMinorTick','off','YMinorTick','off');

%%%% 8(b) effect of group size on Information transfer direction 
figure('units','inches','position',[2 5 3 2.5]);
load('Info_turnStart_T.mat')
plot(N_all,Ang*180/pi,'ko','MarkerSize',10,'MarkerFaceColor',[0.3 1 0.3]);hold on
load('Info_turnStart_M.mat')
plot(N_all,Ang*180/pi,'k^','MarkerSize',10,'MarkerFaceColor',[1 0.3 0.3]);hold on
axis([0 200 0 180]);
set(gca,'Position',[0.15 0.15 0.75 0.75])
set(gca,'FontSize',12,'FontName','times','TickLength',[0.03, 0.01],...
    'XMinorTick','off','YMinorTick','off');

%%%% 8(c) effect of polarization on volume of first birds 
figure('units','inches','position',[5 2 3 2.5]);
load('Info_turnStart_T.mat')
h1=plot(p_all,Vsub2all,'ko','MarkerSize',10,'MarkerFaceColor',[0.3 1 0.3]);hold on
load('Info_turnStart_M.mat')
h2=plot(p_all,Vsub2all,'k^','MarkerSize',10,'MarkerFaceColor',[1 0.3 0.3]);hold on
axis([0.7 1 0 1]);
set(gca,'Position',[0.15 0.15 0.75 0.75])
set(gca,'FontSize',12,'FontName','times','TickLength',[0.03, 0.01],...
    'XMinorTick','off','YMinorTick','off');

%%%% 8(d) effect of group size on volume of first birds 
figure('units','inches','position',[5 5 3 2.5]);
load('Info_turnStart_T.mat')
plot(N_all,Vsub2all,'ko','MarkerSize',10,'MarkerFaceColor',[0.3 1 0.3]);hold on
load('Info_turnStart_M.mat')
plot(N_all,Vsub2all,'k^','MarkerSize',10,'MarkerFaceColor',[1 0.3 0.3]);hold on
axis([0 200 0 1]);
set(gca,'Position',[0.15 0.15 0.75 0.75])
set(gca,'FontSize',12,'FontName','times','TickLength',[0.03, 0.01],...
    'XMinorTick','off','YMinorTick','off');
