%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data Analysis Code
% Manuscript titled: "Collective turns in jackdaw flocks: kinematics and information transfer"
% Authors: Hangjian Ling, Guillam E. Mclvor, Joseph Westley, Kasper van der Vaart, Jennify Yin
%          Richard T. Vaughan, Alex Thornton, Nicholas T. Ouellette
% Manuscript submited to "Journal of The Royal Society Interface"
% Date 2019/06
% writen by: Hangjian Ling 
%            Stanford University
% email:     linghj@stanford.edu
%% Figure S9: information propagate through flocks for all mobbing flocks
%         S10: plot profiles of di(ti) for all mobbing flocks
clear all;clc
load('/Users/ling/Downloads/ScientificColourMaps5/roma/roma.mat');
%%%% analyze all the mobbing flocks
% for i=1:8
%     load(['turns_mobbing/',sprintf('group_%02d.mat',i)]);
%     [Rank,Delay]=GetRank(tracks); % get rank
%     [Density,Order]=GetDensityOrder(tracks);% get flock density and polarization
%     Rank=sort(Rank);% get information transfer distance
%     InfoDis=((Rank-1)/Density).^(1/3);
%     N=length(unique(tracks(:,1)));
%     save(['turns_mobbing/',sprintf('group_delay_%02d.mat',i)],'InfoDis','Delay','Order','N');
% end
%% Figure 9(a): plot bird distribution color by ti
% load('turns_mobbing/group_01.mat');
% load(['turns_mobbing/','group_delay_01.mat']);
% T=unique(tracks(:,5));
% id=find(tracks(:,5)==T(1)); % time frame when turn start
% u=tracks(id,6:8);
% U=mean(u,1);   
% theta_temp=atan(U(2)/U(1));
% R = [cos(theta_temp) -sin(theta_temp); sin(theta_temp) cos(theta_temp)];
% UR=U(1:2)*R;UR(3)=U(3);
% for j=1:size(tracks,1)
%     if UR(1)>0
%         tracks(j,2:3) = tracks(j,2:3)*R; 
%         tracks(j,6:7)=tracks(j,6:7)*R;
%     elseif UR(1)<0
%         tracks(j,2:3) = tracks(j,2:3)*R*(-1); 
%         tracks(j,6:7)=tracks(j,6:7)*R*(-1);  
%     end
% end
% [T,TR]=GetGroupProp(tracks);
% Tmiddle=find(TR>0.1*max(TR));
% id=find(tracks(:,5)==T(min(Tmiddle))); % time frame when turn start
% xyz=tracks(id,2:4);
% u=tracks(id,6:8);
% u=u./sqrt(sum(u.*u,2));
% figure('units','inches','position',[2 2 3.2 2.5]); 
% scatter(xyz(:,1),xyz(:,2),80,Delay,'o','filled',...
%     'LineWidth',1,'MarkerEdgeColor',[0.3 0.3 0.3]);hold on
% quiver(xyz(:,1),xyz(:,2),u(:,1),u(:,2),...
%     'color',[0.2 0.2 0.2],'linewidth',1,'AutoScaleFactor',0.5)
% colormap(roma);box on
% caxis([0 round(max(Delay),1)]);
% colorbar('ticks',[0 round(max(Delay),1)],'FontSize',11,...
%     'Location','east','Position',[0.86 0.3 0.04 0.4]);
% set(gca,'Position',[0.15 0.15 0.70 0.75]);
% set(gca,'FontSize',12,'FontName','times','TickLength',[0.03, 0.01],...
%     'XMinorTick','on','YMinorTick','on');

%% 9(b) plot profile of di(ti) for all mobbing flocks
figure('units','inches','position',[5 2 5 4.5]); 
load(['turns_mobbing/','group_delay_05.mat']);
Delay=sort(Delay);   
h5=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'<','filled','MarkerEdgeColor','k');hold on 

load(['turns_mobbing/','group_delay_04.mat']);
Delay=sort(Delay);   
h4=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'>','filled','MarkerEdgeColor','k');hold on 

load(['turns_mobbing/','group_delay_03.mat']);
Delay=sort(Delay);   
h3=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'^','filled','MarkerEdgeColor','k');hold on 

load(['turns_mobbing/','group_delay_07.mat']);
Delay=sort(Delay);   
h7=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'p','filled','MarkerEdgeColor','k');hold on

load(['turns_mobbing/','group_delay_01.mat']);
Delay=sort(Delay);   
h1=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'o','filled','MarkerEdgeColor','k');hold on 

load(['turns_mobbing/','group_delay_02.mat']);
Delay=sort(Delay);   
h2=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'v','filled','MarkerEdgeColor','k');hold on 

load(['turns_mobbing/','group_delay_06.mat']);
Delay=sort(Delay);   
h6=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'s','filled','MarkerEdgeColor','k');hold on 

load(['turns_mobbing/','group_delay_08.mat']);
Delay=sort(Delay);   
h8=scatter(Delay,InfoDis,50,repmat(N,1,length(Delay)),'h','filled','MarkerEdgeColor','k');hold on 

colormap(roma);caxis([0 80])
colorbar('ticks',[0 80],'FontSize',11,...
    'Location','north','Position',[0.2 0.8 0.4 0.04]);

set(gca,'Position',[0.15 0.15 0.75 0.75])
set(gca,'FontSize',12,'FontName','times','TickLength',[0.03, 0.01],...
    'XMinorTick','on','YMinorTick','on'); % 'xscale','log','yscale','log'
legend([h1 h2 h3 h4 h5 h6 h7 h8],{'#M01','#M02','#M03','#M04','#M05','#M06','#M07','#M08'})

% x_fit=0:0.1:4;
% p=polyfit(Delay(1:end),InfoDis(1:end),1)
% plot(x_fit,polyval(p,x_fit),'k--','LineWidth',1); 

% %%%% for summar flocks
% Order=[0.88 0.83 0.79 0.87 0.84 0.92 0.88 0.94];
% N=[8 4 44 57 70 5 34 4];
% Cs_H=[4.9 4.1 7.4 6.5 7.4 4.2 8.0 3.9];
% Cs_L=[3.9 2.4 5.2 5.3 6.2 2.3 7.0 1.5];
% Cs=(Cs_H+Cs_L)/2;
% Err=(Cs_H-Cs_L)/2;
% save('Cs_SM.mat','N','Order','Cs','Err');
% % 
% % figure('units','inches','position',[2 2 3 2.5]); 
% % load('Cs_SM.mat');
% % errorbar(N,Cs,Err,'k','LineWidth',1.5,'LineStyle','none');hold on
% % plot(N,Cs,'k^','MarkerSize',10,'MarkerFaceColor',[1 0.3 0.3]);hold on
% % 
% % load('Cs_WT.mat');
% % errorbar(N,Cs,Err,'k','LineWidth',1.5,'LineStyle','none');hold on
% % plot(N,Cs,'ko','MarkerSize',10,'MarkerFaceColor',[0.3 1 0.3]);hold on
% % 
% % x_fit=1:80;
% % y_fit=6.6-3.7*exp(-1*x_fit/14.3);
% % h=plot(x_fit,y_fit,'r-','LineWidth',1.5);
% % axis([0 80 0 15]);box off;
% % set(gca,'Position',[0.15 0.15 0.75 0.75])
% % set(gca,'FontSize',12,'FontName','times','TickLength',[0.03, 0.01],...
% %     'xscale','linear','yscale','linear','XMinorTick','on','YMinorTick','on'); 


% 
function [T,TR]=GetGroupProp(tracks)
%%%% get time-dependent group density, order, speed, Ang
T=unique(tracks(:,5));
id=find(tracks(:,5)==T(1));
u=tracks(id,6:8); 
u_ave=mean(u,1);
u_pre=u_ave/sqrt(sum(u_ave.*u_ave));
Ang(1:length(T))=0;
for i=1:length(T)
    id=find(tracks(:,5)==T(i));
    xyz=tracks(id,2:4); 
    u=tracks(id,6:8); 
    a=tracks(id,9:11); 
    U=sum(u.^2,2).^0.5;
    u_norm=u./U;    
    %%%% speed
    u_ave=mean(u,1);
    U_ave(i)=sqrt(sum(u_ave.*u_ave));
    %%%% change of angle
    u_ave_norm=u_ave/U_ave(i);
    if i>=2
        Ang(i)=Ang(i-1)+abs(acos(sum(u_ave_norm.*u_pre))); % *180/pi
        u_pre=u_ave_norm;
    end
    %%%% turn raidal acceleration
    a_ave=mean(a,1);
    An_temp=cross(u_ave,a_ave);
    An(i)=sqrt(sum(An_temp.*An_temp))/U_ave(i); 
    %%%% turn radius
    R(i)=U_ave(i)^2/An(i); 
    %%%% turn rate
    TR(i)=U_ave(i)/R(i);
end
end
