function [Density,Order]=GetDensityOrder(tracks)
%%%%%%%%%%%%% function
% Calculate the group density
% input: tracks (1:n,1:12) where n is number of birds 
%                  (:,1) - bird id
%                  (:,2:4) - bird position
%                  (:,5) - time 
%                  (:,6:8) - velocity 
%                  (:,9:11) - acceleration 
%                  (:,12) - wingbeat
BirdIDs=unique(tracks(:,1));
T=unique(tracks(:,5));
Info.size=length(BirdIDs);
for i=1:length(T)
    id=find(tracks(:,5)==T(i));
    xyz=tracks(id,2:4); 
    u=tracks(id,6:8); 
    %%%% group order
    p(i)=1/size(u,1)*sum((sum(u./sum(u.^2,2).^0.5,1)).^2)^0.5;
    %%%% group density
    D_temp=[];
    for j=1:size(xyz,1)
        Dist_rank=sum((xyz-xyz(j,:)).^2,2).^0.5;        
        D_temp=[D_temp;max(Dist_rank)];
    end
    D(i)=Info.size/mean(D_temp)^3*6/pi;
end
Order=mean(p);
Density=mean(D);
end
