%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% .mat track file into .txt track file
% writen by: Hangjian Ling 
%            Stanford University
% email:     linghj@stanford.edu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Data format: 
%     tracks(:,1) = bird id number
%     tracks(:,2:4) = bird position in Cartesian coordinate system
%     tracks(:,5) = time 
%     tracks(:,6:8) = bird velocity 
%     tracks(:,9:11) = bird acceleration 
%     tracks(:,12) = wingbeat 
clear all;clc
%% Combine all 13 transit flocks .mat data into one .txt file
newFile='DataS1.txt';
fileID = fopen(newFile,'w');
fprintf(fileID,'%2s %6s %8s %10s %6s %6s %6s %6s %6s %6s %6s %6s\n',...
    'ID','x,m','y,m','z,m','t,s','u,m/s','v,m/s','w,m/s',...
    'ax,m/s2','ay,m/s2','az,m/s2','f_wb,Hz');
for i=1:13
    load(['turns_transit/',sprintf('Group_%02d.mat',i)]); % transit flock #0i
    fprintf(fileID,[sprintf('***** transit flock #%02d ******',i),'\n']);
    fprintf(fileID,'%d %.2f %.2f %.2f %.4f %.2f %.2f %.2f %.4f %.4f %.4f %.4f\n',tracks(:,1:12)');
end
fclose(fileID);

%% Combine all 8 mobbing flocks .mat data into one .txt file
newFile='DataS2.txt';
fileID = fopen(newFile,'w');
fprintf(fileID,'%2s %6s %8s %10s %6s %6s %6s %6s %6s %6s %6s %6s\n',...
    'ID','x,m','y,m','z,m','t,s','u,m/s','v,m/s','w,m/s',...
    'ax,m/s2','ay,m/s2','az,m/s2','f_wb,Hz');
for i=1:8
    load(['turns_mobbing/',sprintf('Group_%02d.mat',i)]); % transit flock #0i
    fprintf(fileID,[sprintf('***** mobbing flock #%02d ******',i),'\n']);
    fprintf(fileID,'%d %.2f %.2f %.2f %.4f %.2f %.2f %.2f %.4f %.4f %.4f %.4f\n',tracks(:,1:12)');
end
fclose(fileID);
